var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "led-wizard.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

function cleanUp() {
	if (Property.getNode('myData')==null)
		return;
	var oArray=Property.getNode('myData').getChildren();
	for (var iIndex=0;iIndex<oArray.length;iIndex++) {
		try {
			oArray[iIndex].removeChild('curves');
		} catch (e) {
			
		}
	}
}

function getFeed() {
	var sString=Property.getNode('/system/version/distroVersion').getValue();
	if (sString.indexOf('devel')>=0)
		return 0;
	if (sString.indexOf('test')>=0)
		return 1;
	if (sString.indexOf('beta')>=0)
		return 2;
	if (sString.indexOf('alpha')>=0)
		return 2;
	
	return 3;
}


function storeSubParameter(path, value) {
    try 
    {
        lInfo.logln("StoreSubParameter Path " + path  + " value " + value + " type " + typeof(value));
        Property.setProperty(path, value);
        Property.setFlag(path, 'ARCHIVE', true);
    }
    catch (e)
    {
        lWarn.logln("Fehler beim StoreSubParameter " + e + " Path " + path  + " value " + value);
    }        
}

function fetchDataForManufacture(supplierID) {
	Property.load();
    var h = new HTTP( { 'debug' : 0 }, {});
    lInfo.logln("http://illuminant-wizard.aizo.net/staticDB.php?illuminantMeta2=" + supplierID + "&feed=" + getFeed());
    var code = h.get("http://illuminant-wizard.aizo.net/staticDB.php?illuminantMeta2=" + supplierID + "&feed=" + getFeed());
    if (Property.getNode('myData')!=null) {
	    var oOldArray=Property.getNode('myData').getChildren();
	    for (var iIndex=0;iIndex<oOldArray.length;iIndex++) {
	    	Property.getNode('myData').removeChild(oOldArray[iIndex].getName());
	    }
    }
    if (code.status.valueOf() === 200) {
    	var DataObject=JSON.parse(code.body);
    	var oIlluIDSaved=[];
    	for (var iIndex=0;iIndex<DataObject.length;iIndex++) {
    		try {
				var illuID=DataObject[iIndex].id;
				storeSubParameter('myData/illuminant' + illuID + '/id',illuID);
				storeSubParameter('myData/illuminant' + illuID + '/data',JSON.stringify(DataObject[iIndex]));
			    oIlluIDSaved.push(illuID);
    		} 
    		catch (e) {
    	        lWarn.logln("Error during resyncing cache");
    	        for (var i in e) {
    	            lWarn.logln(i + ': ' + e[i]);
    	        }
    		}
    	}
	    Property.store();
	
    	Property.setProperty('/scripts/led-wizard/subscriptions/' + supplierID,true);
    	new Event('led-wizard.data-segmented' + supplierID,{actions:'fetchQueued','index':0,'illuminants':JSON.stringify(oIlluIDSaved)}).raise();
    }	
}

function fetchDataForIlluminant(supplierID) {
	var oArray=JSON.parse(raisedEvent.parameter.illuminants);
	var iIndex=parseInt(''+raisedEvent.parameter.index,10);
	if (iIndex<oArray.length) {
    	var illuID=oArray[iIndex];
    	var h = new HTTP( { 'debug' : 0 }, {});
        var codeSub = h.get("http://illuminant-wizard.aizo.net/staticDB.php?illuminant=" + illuID + "&feed=" + getFeed());
        if (codeSub.status.valueOf() === 200) {
    		var oDBObject=JSON.parse(codeSub.body);
        	storeSubParameter('myData/illuminant' + illuID + '/curves',codeSub.body);
        } 
    	new Event('led-wizard.data-segmented' + supplierID,{actions:'fetchQueued','index':iIndex+1,'illuminants':raisedEvent.parameter.illuminants}).raise();
    } else {
    	new Event('led-wizard.data-segmented' + supplierID,{actions:'cleanup'}).raise();
    }
}

function prepareSubscription (id) {
	if (Property.getProperty('subscriptions/' + id)==null) {
		var oSubscripion=new Subscription('led-wizard.data-segmented' + id,'javascript',
				{'filename1':'/usr/share/dss/data/scripts/http.js',
			     'filename2':'/usr/share/dss/add-ons/led-wizard/fetchSegmentedData.js','script_id':'led-wizard.manufacture-' + id});
		oSubscripion.subscribe();
		
		var oSubscripion=new Subscription('led-wizard.query-'+ id,'javascript',
				{'filename1':'/usr/share/dss/data/scripts/http.js',
			     'filename2':'/usr/share/dss/add-ons/led-wizard/query.js','script_id':'led-wizard.manufacture-' + id});
		oSubscripion.subscribe();
		
		Property.setProperty('subscriptions/' + id,false);
	}
}

function fetchStaticData() {
    var db_data;
    var db_update;
    var strategy='brute';
    if (raisedEvent.parameter.strategy!=null)
    	strategy=raisedEvent.parameter.strategy;
    try {
    	
    	if (strategy=='startup')
    		if (Property.getNode('db/manufacture')!=null) {		
    			lInfo.logln('starting up, but there are data present, so no wasting time with new fetch');
    			var sManuObject=JSON.parse(Property.getProperty('db/manufacture'));
                for(var iIndex=0;iIndex<sManuObject.length;iIndex++) {
                	prepareSubscription(sManuObject[iIndex].id);
                	new Event('led-wizard.query-'+ sManuObject[iIndex].id,{}).raise();
                }
    			return;
    		}
    	
    	if (strategy=='nicely') {
    		var iSek=Math.floor((Math.random() * 60*60*5) + 1);
    		lInfo.logln('delaying the daily download with ' + iSek);
    		new Event('led-wizard.data-static',{'strategy':'relayedNicely', 'time' : '+' + iSek}).raise();
    		return;
    	}
    	
        var h = new HTTP( { 'debug' : 0 }, {});
        lInfo.logln("http://illuminant-wizard.aizo.net/staticDB.php?feed=" + getFeed());
        var code = h.get("http://illuminant-wizard.aizo.net/staticDB.php?feed=" + getFeed(), 'staticDB.php?feed=' + getFeed());
        if (code.status.valueOf() === 200) {
            //lInfo.logln('OK [' + code.status + ']' + code.body);           
            var oAnswer=JSON.parse(code.body);
            var fFound=false;
            for (var iIndex=0;iIndex<oAnswer.manufacture.length;iIndex++) {
            	if (oAnswer.manufacture[iIndex].id==-1)
            		fFound=true;
            }
            if (!fFound)
            	oAnswer.manufacture.push({id:-1,name:'Standard',url:'www.aizo.com'});
            oAnswer.mountingForm.push({id:-1,name:'-'});
            oAnswer.socket.push({id:-1,name:'-'});
            oAnswer.abilityDetail.push({id:"-1",name:"-"});
            
            storeSubParameter("db/manufacture",JSON.stringify(oAnswer.manufacture));
            storeSubParameter("db/mountingForm",JSON.stringify(oAnswer.mountingForm));
            storeSubParameter("db/socket",JSON.stringify(oAnswer.socket));
            storeSubParameter("db/abilityDetail",JSON.stringify(oAnswer.abilityDetail));
          
            Property.store();
            for(var iIndex=0;iIndex<oAnswer.manufacture.length;iIndex++)
            	prepareSubscription(oAnswer.manufacture[iIndex].id);
            if (strategy=='brute')            
            	for(var iIndex=0;iIndex<oAnswer.manufacture.length;iIndex++)
                    new Event('led-wizard.data-segmented'+oAnswer.manufacture[iIndex].id,{}).raise();
            else {
                for(var iIndex=0;iIndex<oAnswer.manufacture.length;iIndex++)
                	new Event('led-wizard.data-segmented'+oAnswer.manufacture[iIndex].id,{'time':'+' +(iIndex*10)}).raise();
            }
            	
        } else {
            lWarn.logln(sString + ': FAILED! Server replied: "' + code.status + '"');
            lInfo.logln(code.body);
        }
    } catch (e) {
        lWarn.logln("Error during resyncing cache");
        for (var i in e) {
            lWarn.logln(i + ': ' + e[i]);
        }
    }

}

if (raisedEvent.name=='led-wizard.data-static') {
	Property.load();
	if ((raisedEvent.parameter.actions!=null) && (raisedEvent.parameter.actions=='check')) {
		var oArray=Property.getNode('subscriptions').getChildren();
		var fReady=Property.getProperty('shouldMessage');
		
		Property.setProperty('references/' + raisedEvent.parameter.supplierID,raisedEvent.parameter.illuminants);
		for (var iIndex=0;iIndex<oArray.length;iIndex++) {
			if (oArray[iIndex].getValue()==false)
				fReady=false;
		}
		if (fReady) {
			Property.setProperty('shouldMessage',false);
			lInfo.logln('DB READY!!!!');
			storeSubParameter("dbrefresh",""+(new Date()).getTime());
			new Event('led-wizard.answer',{result:true,error:'',type:'saveDB'}).raise();
			lInfo.logln('look into list if something to do');
			new Event('led-wizard.prog',{actions:'programmCurveStartQueue',retry:true}).raise();
			
			Property.store();
		}
	} else if (raisedEvent.parameter.actions=='sqlimport') {
		lInfo.logln('startup sql import');
		new Event('led-wizard.sqlimport',{}).raise();
	} else {
		lInfo.logln('start fetching new data segmented way');
		Property.setProperty('shouldMessage',true);
		fetchStaticData();
	}
} else {	
	if (raisedEvent.parameter.actions==null) {
	
		Property.setProperty("manufacture", "?");
		var pProperty=Property.getNode('manufacture').getPath();	
		lInfo.logln('starting fetch for: ' + pProperty.substr(32,pProperty.indexOf("/manu")-32));
		Property.setProperty("manufacture", pProperty.substr(32,pProperty.indexOf("/manu")-32));
		fetchDataForManufacture(pProperty.substr(32,pProperty.indexOf("/manu")-32));
		
	} else if (raisedEvent.parameter.actions=='fetchQueued') {
		Property.setProperty("manufacture", "?");
		var pProperty=Property.getNode('manufacture').getPath();	
		lInfo.logln('queued fetch for: ' + pProperty.substr(32,pProperty.indexOf("/manu")-32) + ' index: ' + raisedEvent.parameter.index);
		Property.setProperty("manufacture", pProperty.substr(32,pProperty.indexOf("/manu")-32));
		fetchDataForIlluminant(pProperty.substr(32,pProperty.indexOf("/manu")-32));	
		
	} else if (raisedEvent.parameter.actions=='cleanup') {

		Property.setProperty("manufacture", "?");
		var pProperty=Property.getNode('manufacture').getPath();	
		lInfo.logln('cleanup for : ' + pProperty.substr(32,pProperty.indexOf("/manu")-32));
		Property.setProperty("manufacture", pProperty.substr(32,pProperty.indexOf("/manu")-32));
		var supplierID=(pProperty.substr(32,pProperty.indexOf("/manu")-32));
		
		var oIlluIDSaved=[];
		var oPropertyArray=Property.getNode('myData').getChildren();
    	for (var iIndex=0;iIndex<oPropertyArray.length;iIndex++) {    		
			var illuID=oPropertyArray[iIndex].getChild('id').getValue();
		    oIlluIDSaved.push(illuID);    		 
    	}
	    Property.store();
		cleanUp();	
    	Property.setProperty('/scripts/led-wizard/subscriptions/' + supplierID,true);
    	new Event('led-wizard.data-static',{actions:'check','supplierID':supplierID,'illuminants':JSON.stringify(oIlluIDSaved)}).raise();
		
	}
}